
#include "unix.h"

typedef struct _Point {
    float x, y, z;
} Point;


Cylinder( xaxis, yaxis, zaxis, center, depth,
          clockwise, top, bottom, primitive )
float xaxis, yaxis, zaxis;
Point center;
int depth;
char clockwise, top, bottom;
int primitive;
{
    int i, j;        /* i/length    j/theta */
    float is, js;
    float theta, step, lstep;
    float flengthSize, fthetaSize;
    int lengthSize, thetaSize;
    Point cylinder[130][260];
    FILE *fp;
    extern char *filename;

    fp = fopen( filename, "w" );

    step = (float)(M_PI / pow( (double)2, (double)depth ));
#if( 0 ) 
    lstep = (float)(yaxis / pow( (double)2, (double)depth ));
#endif		/*  */
    lstep = (float)(xaxis / pow( (double)2, (double)depth ));
#if( 0 ) 
    flengthSize = (yaxis / lstep) + 1.;
#endif		/*  */
    flengthSize = (xaxis / lstep) + 1.;
    fthetaSize = (2 * M_PI / step) + 1.;
    lengthSize = (int)flengthSize;
    thetaSize = (int)fthetaSize;

    for( i = 0; i < lengthSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            is = i * lstep;   js = j * step;
            cylinder[i][j].x = -(xaxis/2) + is   + center.x;
            cylinder[i][j].y = yaxis * cos( js ) + center.y;
#if( 0 ) 
            cylinder[i][j].x = xaxis * cos( js ) + center.x;
            cylinder[i][j].y = -(yaxis/2) + is   + center.y;
#endif		/*  */
            cylinder[i][j].z = zaxis * sin( js ) + center.z;
        }
    }

    fprintf( fp, "%d\t", lengthSize * thetaSize );
    if( top && bottom )
        fprintf( fp, "%d\t", (lengthSize-1) * (thetaSize-1) + 2 );
    else if( top || bottom )
        fprintf( fp, "%d\t", (lengthSize-1) * (thetaSize-1) + 1 );
#if( 0 ) 
    else
        fprintf( fp, "%d\t", 2 * (lengthSize-1) * (thetaSize-1) );
#endif		/*  */
    else
        fprintf( fp, "%d\t", (lengthSize-1) * (thetaSize-1) );

    if( top && bottom )
        fprintf( fp, "%d\n", 4 * (lengthSize-1) * (thetaSize-1) + 2 * thetaSize );
    else if( top || bottom )
        fprintf( fp, "%d\n", 4 * (lengthSize-1) * (thetaSize-1) + thetaSize );
#if( 0 ) 
    else
        fprintf( fp, "%d\n", 6 * (lengthSize-1) * (thetaSize-1) );
#endif		/*  */
    else
        fprintf( fp, "%d\n", 4 * (lengthSize-1) * (thetaSize-1) );


    /* Print the Coordinates of the points */
    for( i = 0; i < lengthSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            fprintf( fp, "%f %f %f\n", cylinder[i][j].x, cylinder[i][j].y,
                                       cylinder[i][j].z );
        }
    }

    /* Print the Conectivity data of the points */
    if( clockwise )  {
        if( bottom ) {
            fprintf( fp, "%d ", thetaSize );
            for( i = thetaSize-1; i >= 0; i-- ) {
                fprintf( fp, "%d ", 0*thetaSize+i+1 );
            }
            fprintf( fp, "\n" );
        }
#if( 0 ) 
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < lengthSize-1; j++ ) {
                fprintf( fp, "3 %d %d %d\n",
                           j*thetaSize+i+1,     j*thetaSize+(i+1)+1,
                   (j+1)*thetaSize+(i+1)+1 );
                fprintf( fp, "3 %d %d %d\n",
                   (j+1)*thetaSize+(i+1)+1, (j+1)*thetaSize+i+1,
                           j*thetaSize+i+1 );
            }
        }
#endif		/*  */
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < lengthSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1,     j*thetaSize+(i+1)+1,
                   (j+1)*thetaSize+(i+1)+1, (j+1)*thetaSize+i+1 );
            }
        }
        if( top ) {
            fprintf( fp, "%d ", thetaSize );
            for( i = 0; i < thetaSize; i++ ) {
                fprintf( fp, "%d ", (lengthSize-1)*thetaSize+i+1 );
            }
            fprintf( fp, "\n" );
        }
    }
    else {    /* counterClockwise */
        if( bottom ) {
            fprintf( fp, "%d ", thetaSize );
            for( i = 0; i < thetaSize; i++ ) {
                fprintf( fp, "%d ", 0*thetaSize+i+1 );
            }
            fprintf( fp, "\n" );
        }
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < lengthSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1, (j+1)*thetaSize+i+1,
                   (j+1)*thetaSize+(i+1)+1, j*thetaSize+(i+1)+1 );
            }
        }
        if( top ) {
            fprintf( fp, "%d ", thetaSize );
            for( i = thetaSize-1; i >= 0; i-- ) {
                fprintf( fp, "%d ", (lengthSize-1)*thetaSize+i+1 );
            }
            fprintf( fp, "\n" );
        }
    }
    fclose( fp );
}
