
#include "objects.h"

EllipticParaboloid( xaxis, yaxis, zaxis, length, center, depth,
                    clockwise, primitive )
float xaxis, yaxis, zaxis, length;
Point center;
char clockwise;
int primitive;
{
    int i, j;        /* i/length    j/theta */
    float is, js;
    float theta, step, lstep;
    float flengthSize, fthetaSize;
    int lengthSize, thetaSize;
    Point elliptic[130][260];
    FILE *fp;
    extern char *filename;

    fp = fopen( filename, "w" );

    step = (float)(M_PI / pow( (double)2, (double)depth ));
    lstep = (float)(length / pow( (double)2, (double)depth ));
    flengthSize = (length / lstep) + 1.;
    fthetaSize = (2 * M_PI / step) + 1.;
    lengthSize = (int)flengthSize;
    thetaSize = (int)fthetaSize;

    for( i = 0; i < lengthSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            is = i * lstep;
            js = -M_PI + j * step;
            elliptic[i][j].x = xaxis * is * cos( js ) + center.x;
            elliptic[i][j].y =    is * is             + center.y;
            elliptic[i][j].z = zaxis * is * sin( js ) + center.z;
        }
    }

    /* Print the Coordinates of the points */
    fprintf( fp, "%d\n", lengthSize * thetaSize );
    for( i = 0; i < lengthSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            fprintf( fp, "%f %f %f\n", elliptic[i][j].x, elliptic[i][j].y,
                                  elliptic[i][j].z );
        }
    }

    /* Print the Conectivity data of the points */
    fprintf( fp, "%d\n", (lengthSize-1) * (thetaSize-1) );
    if( clockwise )  {
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < lengthSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1,     j*thetaSize+(i+1)+1,
                   (j+1)*thetaSize+(i+1)+1, (j+1)*thetaSize+i+1 );
            }
        }
    }
    else {    /* counterClockwise */
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < lengthSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1, (j+1)*thetaSize+i+1,
                   (j+1)*thetaSize+(i+1)+1, j*thetaSize+(i+1)+1 );
            }
        }
    }
}
