
#include "objects.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "externs.h"
#include <sys/time.h>

void readTorusValues();
int checkTorusValues();
extern ObjectStruct ObjectValues;

#define ASCIITEXTATTRIBUTES \
    XtNeditType, XawtextEdit, \
    XtNtype, XawAsciiString, \
    XtNuseStringInPlace, True, \
    XtNresizable, True, \
    XtNresize, XawtextResizeWidth, \
    XtNright, XtChainRight,


typedef struct _Text {
    char *filetext;
    char *textC;
    char *text1, *text2, *text3,
    *text4, *text5, *text6,
    *n1, *n2;
} 
Text, *TextPtr;


typedef struct _Widg {
    Widget cl, tp, bt;
} 
Widg, *WidgPtr;


typedef struct _Pass {
    TextPtr text;
    WidgPtr widg;
} 
Pass, *PassPtr;


/*
 *   Function Name: getOFFValues
 *   Description: Creates and pops up the Dialog widget to ask for a new
 *                input values
 *   Arguments: w - the command button that activated this function.
 *   Returns: none.
 */

void
generateTorus( toplevel )
Widget toplevel;
{
    TextPtr   text = (TextPtr) malloc( sizeof (Text) );
    WidgPtr   widg = (WidgPtr) malloc( sizeof (Widg) );
    PassPtr   pass = (PassPtr) malloc( sizeof (Pass) );

    Widget    g_popup, g_form;
    Widget    g_label0, g_filelabel, g_filetext;
    Widget    g_label1, g_label3, g_label4, g_label5, g_label6,
              g_ln1, g_ln2,
              g_label7, g_label8, g_label9;
    Widget    g_text1, g_text3, g_text4, g_text5, g_text6, g_n1, g_n2,
              g_toggle7;
    Widget    g_label000, g_label001, g_label002;
    Widget    g_ok, g_cancel;
    Widget    g_title1, g_title2;
    Widget    g_labelC, g_textC;

    Position x, y;

    char   string[20];
    String buffer;

    struct timeval tp;
    struct timezone tzp;

    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    ObjectValues.Obj.Torus.radius = 1.5;
    ObjectValues.Obj.Torus.xaxis = 0.3;
    ObjectValues.Obj.Torus.yaxis = 0.3;
    ObjectValues.Obj.Torus.zaxis = 0.3;
    ObjectValues.Obj.Torus.depth = 3;
    ObjectValues.Obj.Torus.center.x = 0.0;
    ObjectValues.Obj.Torus.center.y = 0.0;
    ObjectValues.Obj.Torus.center.z = 0.0;
    ObjectValues.Obj.Torus.n1 = 1;
    ObjectValues.Obj.Torus.n2 = 1;
    ObjectValues.Obj.Torus.clockwise = False;

    map_dialog(toplevel, &x, &y);
    g_popup = XtVaCreatePopupShell( "Get Values",
        transientShellWidgetClass, toplevel,
        XtNx, x, XtNy, y,
        NULL );

    g_form = XtVaCreateManagedWidget( "g_form", formWidgetClass, g_popup,
        NULL );

    sprintf( string, "Object : Torus" );
    g_label0 = XtVaCreateManagedWidget( "g_label0", labelWidgetClass, g_form,
        XtNlabel, string,
        NULL );

    gettimeofday( &tp, &tzp );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "torus_%d.geom", (tp.tv_sec)%1000 );
    text->filetext = XtNewString( buffer );
    g_filelabel = XtVaCreateManagedWidget( "g_filelabel", labelWidgetClass,
        g_form,
        XtNfromVert, g_label0,
        NULL );
    g_filetext = XtVaCreateManagedWidget( "g_filetext", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->filetext,
        XtNlength, 30,
        XtNwidth, 11*strlen(buffer),
        XtNinsertPosition, strlen(buffer),
        XtNfromVert, g_label0,
        XtNfromHoriz, g_filelabel,
        NULL );

    g_label000 = XtVaCreateManagedWidget( "g_label000", labelWidgetClass,g_form,
        XtNfromVert, g_filelabel,
        NULL );
    g_title1 = XtVaCreateManagedWidget( "g_title1", labelWidgetClass, g_form,
        XtNfromVert, g_label000,
        NULL );

    g_labelC  = XtVaCreateManagedWidget( "g_labelC", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_title1,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f %.2f %.2f", ObjectValues.Obj.Torus.center.x,
        ObjectValues.Obj.Torus.center.y, ObjectValues.Obj.Torus.center.z );
    text->textC = XtNewString( buffer );
    g_textC = XtVaCreateManagedWidget( "g_textC", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textC,
        XtNlength, 25,
        XtNwidth, 11*strlen(text->textC),
        XtNinsertPosition, strlen(text->textC),
        XtNfromVert, g_title1,
        XtNfromHoriz, g_labelC,
        NULL );

    g_label3 = XtVaCreateManagedWidget( "g_label3", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_labelC,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Torus.radius );
    text->text3 = XtNewString( buffer );
    g_text3  = XtVaCreateManagedWidget( "g_text3", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text3,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->text3),
        XtNfromVert, g_labelC,
        XtNfromHoriz, g_label3,
        NULL );

    g_label4 = XtVaCreateManagedWidget( "g_label4", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label3,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Torus.xaxis );
    text->text4 = XtNewString( buffer );
    g_text4  = XtVaCreateManagedWidget( "g_text4", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text4,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->text4),
        XtNfromVert, g_label3,
        XtNfromHoriz, g_label4,
        NULL );

    g_label5 = XtVaCreateManagedWidget( "g_label5", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label4,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Torus.yaxis );
    text->text5 = XtNewString( buffer );
    g_text5  = XtVaCreateManagedWidget( "g_text5", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text5,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->text5),
        XtNfromVert, g_label4,
        XtNfromHoriz, g_label5,
        NULL );

    g_label6 = XtVaCreateManagedWidget( "g_label6", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label5,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Torus.zaxis );
    text->text6 = XtNewString( buffer );
    g_text6  = XtVaCreateManagedWidget( "g_text6", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text6,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->text6),
        XtNfromVert, g_label5,
        XtNfromHoriz, g_label6,
        NULL );

    g_ln1 = XtVaCreateManagedWidget( "g_ln1", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label6,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues.Obj.Torus.n1 );
    text->n1 = XtNewString( buffer );
    g_n1  = XtVaCreateManagedWidget( "g_n1", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->n1,
        XtNlength, 2,
        XtNinsertPosition, strlen(text->n1),
        XtNfromVert, g_label6,
        XtNfromHoriz, g_ln1,
        NULL );

    g_ln2 = XtVaCreateManagedWidget( "g_ln2", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_ln1,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues.Obj.Torus.n2 );
    text->n2 = XtNewString( buffer );
    g_n2  = XtVaCreateManagedWidget( "g_n2", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->n2,
        XtNlength, 2,
        XtNinsertPosition, strlen(text->n2),
        XtNfromVert, g_ln1,
        XtNfromHoriz, g_ln2,
        NULL );

    g_label1 = XtVaCreateManagedWidget( "g_label1", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_ln2,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues.Obj.Torus.depth );
    text->text1 = XtNewString( buffer );
    g_text1  = XtVaCreateManagedWidget( "g_text1", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text1,
        XtNlength, 1,
        XtNinsertPosition, strlen(text->text1),
        XtNfromVert, g_ln2,
        XtNfromHoriz, g_label1,
        NULL );

    g_label001 = XtVaCreateManagedWidget( "g_label001", labelWidgetClass,g_form,
        XtNfromVert, g_label1,
        NULL );

    g_title2 = XtVaCreateManagedWidget( "g_title2", labelWidgetClass, g_form,
        XtNfromVert, g_label001,
        NULL );

    g_label7 = XtVaCreateManagedWidget( "g_label7", labelWidgetClass, g_form,
        XtNfromVert, g_title2,
        NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle7  = XtVaCreateManagedWidget( "g_toggle7", toggleWidgetClass,g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_title2,
        XtNfromHoriz, g_label7,
        NULL );
    if( ObjectValues.Obj.Torus.clockwise )
        XtVaSetValues( g_toggle7, XtNlabel, "+", NULL );
    else
        XtVaSetValues( g_toggle7, XtNlabel, "-", NULL );

    g_label002 = XtVaCreateManagedWidget( "g_label002", labelWidgetClass,g_form,
        XtNfromVert, g_label7,
        NULL );

    widg->cl = g_toggle7;
    pass->text = text;
    pass->widg = widg;

    callbacks[0].callback = (XtCallbackProc) readTorusValues;
    callbacks[0].closure  = (XtPointer) pass;
    g_ok = XtVaCreateManagedWidget( "g_ok", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label002,
        NULL );

    callbacks[0].callback = (XtCallbackProc) DestroyPopupPrompt;
    callbacks[0].closure  = (XtPointer) g_popup;
    g_cancel = XtVaCreateManagedWidget( "g_cancel", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label002,
        XtNfromHoriz, g_ok,
        NULL );

/*
    XtRealizeWidget( g_popup );
*/
    XtPopup( g_popup, XtGrabNone );
    XMapRaised( XtDisplay( g_popup ), XtWindow( XtParent( g_popup ) ) );
}


static void
changeSign( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Boolean state;

    XtVaGetValues( widget, XtNstate, &state, NULL );
    if( state ) XtVaSetValues( widget, XtNlabel, "+", NULL );
    if( !state ) XtVaSetValues( widget, XtNlabel, "-", NULL );
}


static void
DestroyPopupPrompt( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Widget popup = (Widget)client_data;
    extern char creatingObject;
    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


void
readTorusValues( widget, client_data, call_data )
Widget widget;
XtPointer client_data, call_data;
{
    Widget popup = XtParent( XtParent( widget ) );
    PassPtr pass = (PassPtr) client_data;
    WidgPtr pwidg = (WidgPtr) pass->widg;
    TextPtr ptext = (TextPtr) pass->text;
    extern char creatingObject;

    float radius;
    float xaxis, yaxis, zaxis;
    int depth;
    Point center;
    int n1, n2;
    Boolean clockwise;
    Status status;
    int primitive=0;

    extern String filename;

    filename = (String) malloc( strlen((const char *)getenv("OBJ_PATH")) + 80 );

    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), ptext->filetext );
    sscanf( ptext->textC, "%f %f %f", &(center.x), &(center.y), &(center.z) );
    XtFree( ptext->textC );
    sscanf( ptext->text1, "%d", &depth );
    XtFree( ptext->text1 );
    sscanf( ptext->text3, "%f", &radius );
    XtFree( ptext->text3 );
    sscanf( ptext->text4, "%f", &xaxis );
    XtFree( ptext->text4 );
    sscanf( ptext->text5, "%f", &yaxis );
    XtFree( ptext->text5 );
    sscanf( ptext->text6, "%f", &zaxis );
    XtFree( ptext->text6 );
    sscanf( ptext->n1, "%d", &n1 );
    XtFree( ptext->n1 );
    sscanf( ptext->n2, "%d", &n2 );
    XtFree( ptext->n2 );
    XtVaGetValues( pwidg->cl, XtNstate, &clockwise, NULL );

    ObjectValues.Obj.Torus.radius = radius;
    ObjectValues.Obj.Torus.xaxis = xaxis;
    ObjectValues.Obj.Torus.yaxis = yaxis;
    ObjectValues.Obj.Torus.zaxis = zaxis;
    ObjectValues.Obj.Torus.depth = depth;
    ObjectValues.Obj.Torus.center.x = center.x;
    ObjectValues.Obj.Torus.center.y = center.y;
    ObjectValues.Obj.Torus.center.z = center.z;
    ObjectValues.Obj.Torus.n1 = n1;
    ObjectValues.Obj.Torus.n2 = n2;
    ObjectValues.Obj.Torus.clockwise = clockwise;

    if( !(status = checkTorusValues( popup,
        xaxis, yaxis, zaxis, radius, n1, n2, depth, clockwise ) ) )
        Torus( xaxis, yaxis, zaxis, radius, center, n1, n2, depth, clockwise );

    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


int
checkTorusValues( w, xaxis, yaxis, zaxis, radius, n1, n2, depth, clockwise )
Widget w;
float xaxis, yaxis, zaxis, radius;
int n1, n2, depth;
Boolean clockwise;
{
    char buffer[80];
    int errors = 0;

    if( depth < 1 || depth > 7 ) {
        sprintf( buffer, "Error -- Required Condition: 1 <= depth(%d) <= 7\n",
            depth );
        message( w, buffer );
        errors++;
    }
    if( NEAR_ZERO( radius ) ) {
        sprintf( buffer, "Error -- Required Condition: radius(%.2f) > 0.0\n",
            radius );
        message( w, buffer );
        errors++;
    }
    if( NEAR_ZERO( xaxis ) ) {
        sprintf( buffer, "Error -- Required Condition: xaxis(%.2f) > 0.0\n",
            xaxis );
        message( w, buffer );
        errors++;
    }
    if( NEAR_ZERO( yaxis ) ) {
        sprintf( buffer, "Error -- Required Condition: yaxis(%.2f) > 0.0\n",
            yaxis );
        message( w, buffer );
        errors++;
    }
    if( NEAR_ZERO( zaxis ) ) {
        sprintf( buffer, "Error -- Required Condition: zaxis(%.2f) > 0.0\n",
            zaxis );
        message( w, buffer );
        errors++;
    }
    if( (n1%2 == 0) || (n2%2 == 0) ) {
        sprintf( buffer,
            "Error -- Required Condition: n1(%d), n2(%d) e [1,3,5,7,9,...]\n",
            n1, n2 );
        message( w, buffer );
        errors++;
    }
    return errors;
}
