
#ifndef _externs_h
#define _externs_h

#if defined(__STDC__) || defined(__cplusplus)
# define ___P(s) s
#else
# define ___P(s) ()
#endif

/* callbacks.c */
extern void redraw ___P((void));
extern XtActionProc CanvasExpose ___P((Widget w, XEvent *event));
extern XtActionProc CanvasConfigure ___P((Widget w, XEvent *event));
extern XtActionProc CanvasResize ___P((Widget w, XEvent *event));
extern XtActionProc CanvasButtonPress ___P((Widget w, XEvent *event));
extern XtActionProc CanvasButtonRelease ___P((Widget w, XEvent *event));
extern XtActionProc CanvasB1Motion ___P((Widget w, XEvent *event));
extern XtActionProc CanvasB2Motion ___P((Widget w, XEvent *event));
extern XtActionProc CanvasB3Motion ___P((Widget w, XEvent *event));
extern XtActionProc CanvasAbout ___P((void));
extern XtActionProc CanvasReset ___P((void));
#ifndef USE_ATHENA
extern XtActionProc CanvasVisual ___P((Widget w, XtPointer client_data, XmListCallbackStruct *cbs));
#else
extern XtActionProc CanvasVisual ___P((Widget w, XtPointer client_data, XawListReturnStruct *cbs));
#endif
extern XtActionProc CanvasWireframe ___P((Widget w, XEvent *event));
extern XtActionProc CanvasColor ___P((Widget w, XEvent *event));
extern XtActionProc CanvasMaterial ___P((Widget w, XEvent *event));
extern XtActionProc CanvasLight ___P((Widget w, XEvent *event));
extern XtActionProc CanvasView ___P((Widget w, XEvent *event));
extern XtActionProc CanvasDepthCue ___P((Widget w, XEvent *event));
extern XtActionProc CanvasFlybyCr ___P((Widget w, XEvent *event));
extern XtActionProc CanvasFlybyEx ___P((Widget w, XEvent *event));
extern XtActionProc CanvasAnimate ___P((Widget w, XEvent *event));
extern XtActionProc CanvasMorph ___P((Widget w, XEvent *event));
extern XtActionProc CanvasMelt ___P((Widget w, XEvent *event));
extern XtActionProc CanvasVanish ___P((Widget w, XEvent *event));
extern XtActionProc CanvasBackward ___P((Widget w, XEvent *event));
extern XtActionProc CanvasPlay ___P((Widget w, XEvent *event));
extern XtActionProc CanvasForward ___P((Widget w, XEvent *event));
extern XtActionProc CanvasStop ___P((Widget w, XEvent *event));
extern XtActionProc CanvasRecord ___P((Widget w, XEvent *event));
extern XtActionProc CanvasPrint ___P((Widget w, XEvent *event));
extern XtActionProc CanvasQuit ___P((Widget w, XEvent *event));

/* file_selection.c */
extern int is_writable ___P((char *file, char *ext));
#ifndef USE_ATHENA
extern Boolean XmStringGetLtoR ___P((XmString string, XmStringCharSet charset, char **text));
extern XmString XmStringLtoRCreate ___P((char *string, XmStringCharSet charset));
extern XmString XmStringCreateLtoR ___P((char *string, XmStringCharSet charset));
#endif
extern int fileSelection ___P((Widget w));
extern void help_file_cb ___P((Widget w, XtPointer client_data, XtPointer call_data));
#ifndef USE_ATHENA
extern void no_file_cb ___P((Widget w, XtPointer client_data, XmFileSelectionBoxCallbackStruct *cbs));
extern void new_file_cb ___P((Widget w, XtPointer client_data, XmFileSelectionBoxCallbackStruct *cbs));
extern void do_search ___P((Widget fs, XmFileSelectionBoxCallbackStruct *cbs));
#endif

/* get_normals.c */
extern int getNormals ___P((char *path, char *file));

/* init_pex.c */
extern void initPex ___P((OFFObjDesc *Obj));
extern void initialize_material ___P((OFFObjDesc *Obj));
extern void initialize_material_predef ___P((void));
extern void initialize_light_table ___P((OFFObjDesc *Obj));
extern void initialize_depth_cue_table ___P((void));
extern void initialize_view ___P((void));
extern void initialize_view_plane ___P((void));
extern void build_object ___P((OFFObjDesc *Obj));
extern void build_object_shadow ___P((OFFObjDesc *Obj));
extern void build_object_wire ___P((OFFObjDesc *Obj));
extern void build_plane ___P((void));
extern void build_axis ___P((void));

/* main.c */
extern void main ___P((int argc, char *argv[], char *envp[]));
extern void usage ___P((char *prog_name));
extern void parseXtAppArgs ___P((unsigned int argc, char **argv));
extern Boolean WriteAOFF ___P((char *filename));

/* map_dialog.c */
extern void map_dialog ___P((Widget dialog, Position *xpos, Position *ypos));

/* process_file.c */
extern int  strbpos ___P((char *s, int c));
extern int  strin ___P((char *s, char *c));
extern int  processFile ___P((char *some_file));
extern void warning ___P((Widget parent, char *help_text));
extern void blink ___P(());
extern void done ___P((Widget dialog));
extern void destroy_it ___P(());

/* readGeneric.c */
extern int OFFReadGeneric ___P((OFFProperty *pProp, char *fname));

/* readIndPoly.c */
extern int OFFReadIndexedPoly ___P((OFFProperty *pProp, char *fname));

/* readIndexed.c */
extern int OFFReadIndexed ___P((OFFProperty *pProp, char *fname));

/* readObj.c */
extern int OFFReadObj ___P((OFFObjDesc *Obj));

/* user_interface.c */
extern void initXtAppTop ___P((unsigned int argc, char **argv));
extern int MakeMenuButton ___P((Widget Bar, Widget Pane, char *Title, char *ResName, char *Mnwm));
extern void createTopForm ___P((void));
extern XtActionProc quitOFFObject ___P((Widget w));
extern XtActionProc saveOFFObject ___P((Widget w, XtPointer client_data, XtPointer *call_data));
extern XtActionProc loadOFFObject ___P((Widget w, XtPointer client_data, XtPointer *call_data));
extern void errorMessage ___P((int ErrorStatus, char *tag));
extern void createControlPanel ___P((void));
extern void createVideolPanel ___P((void));
extern void createPrintlPanel ___P((void));

#undef ___P

#endif /* _externs_h */

